// ============
// Mixins
// ============

// ------------
// BEM mixins
// For more information about BEM
// @see http://getbem.com/introduction/
// ------------

// Block Element
// @access public
// @param {String} $element - Element's name
@mixin element($element) {
  &__#{$element} {
    @content;
  }
}

// Block Modifier
// @access public
// @param {String} $modifier - Modifier's name
@mixin modifier($modifier) {
  &--#{$modifier} {
    @content;
  }
}

// @alias element
@mixin e($element) {
  @include element($element)  {
    @content;
  }
}

// @alias modifier
@mixin m($modifier) {
  @include modifier($modifier) {
    @content;
  }
}

/* ------------
 * Media query mixins
 * ------------
 */
// At-least mixin for create a media query with proper min-width
// @access public
// @param {String} $width - Width with px
@mixin at-least($width) {
  @media all and (min-width: $width) {
    @content;
  }
}

// At-most mixin for create a media query with proper max-width
// @access public
// @param {String} $width - Width with px
@mixin at-most($width) {
  @media all and (max-width: $width - 1) {
    @content;
  }
}

// Between mixin for create a media query between proper min-width and max-width breakpoints
// @access public
// @param {String} $min-width - Min width with px
// @param {String} $max-width - Ma width with px
@mixin between($min-width, $max-width) {
  @media all and (min-width: $min-width) and (max-width: $max-width - 1) {
    @content
  }
}
